package cn.wise.sc.consume.business.security;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.web.authentication.AbstractAuthenticationProcessingFilter;
import org.springframework.security.web.authentication.www.NonceExpiredException;
import org.springframework.security.web.util.matcher.AntPathRequestMatcher;
import org.springframework.util.StreamUtils;
import org.springframework.util.StringUtils;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.Charset;

public class MyUsernamePasswordAuthenticationFilter extends AbstractAuthenticationProcessingFilter {
	@Autowired
	private StringRedisTemplate stringRedisTemplate;
	private static final String SHIRO_TOKEN_SMSCODE = "shiro:token:smscode";
	public static final String VERIFY_CODE= "RANDOMVALIDATECODEKEY";//放到session中的key


    public MyUsernamePasswordAuthenticationFilter() {
         //拦截url为 "/login" 的POST请求
        super(new AntPathRequestMatcher("/login", "POST"));
    }

    @Override
    public Authentication attemptAuthentication(HttpServletRequest request, HttpServletResponse response)
            throws AuthenticationException, IOException, ServletException {
        //从json中获取username和password
        String body = StreamUtils.copyToString(request.getInputStream(), Charset.forName("UTF-8"));
        String username = null, password = null, verifyInput = null;
        if(StringUtils.hasText(body)) {
            JSONObject jsonObj = JSON.parseObject(body);
            username = jsonObj.getString("username");
            password = jsonObj.getString("password");
	        verifyInput = jsonObj.getString("verifyInput");
        }
        
        if (username == null) 
            username = "";
        if (password == null)
            password = "";
        username = username.trim();

     /*   if(StringUtils.isEmpty(verifyInput)){
	        throw new NonceExpiredException("请输入验证码");
        }
	    String verifyRedis = stringRedisTemplate.opsForValue().get(VERIFY_CODE + username);
	    if (verifyInput == null || verifyRedis==null) {
		    throw new NonceExpiredException("验证码失效");
	    }
	    if (verifyInput.equals(verifyRedis)) {
		    stringRedisTemplate.delete(VERIFY_CODE + username);
	    } else {
		    throw new NonceExpiredException("验证码错误");
	    }*/

       //封装到token中提交
        UsernamePasswordAuthenticationToken authRequest = new UsernamePasswordAuthenticationToken(
                username, password);

         return super.getAuthenticationManager().authenticate(authRequest);
    }

}